﻿var dlgElement;
$(document).ready(function () {
    moment.lang('es');
    dlgElement = $('#domMessage');
    (function ($) {
        $.QueryString = (function (a) {
            if (a == "")
                return {};
            var b = {};
            for (var i = 0; i < a.length; ++i) {
                var p = a[i].split('=');
                if (p.length != 2)
                    continue;
                b[p[0]] = decodeURIComponent(p[1].replace(/\+/g, " "));
            }
            return b;
        })(window.location.search.substr(1).split('&'))
    })(jQuery);
    (function ($) {
        $.Location = (function (loc) {
            var atpos = loc.indexOf("?");
            if (atpos > -1) {
                loc = loc.substring(0, atpos);
            }
            loc = (loc.substr(loc.length - 1, 1) == "/") ? loc + "default.aspx" : loc;
            return loc;
        })(window.location.href)
    })(jQuery);
    ko.utils.stringStartsWith = function (string, startsWith) {
        string = string || "";
        if (startsWith.length > string.length)
            return false;
        return string.substring(0, startsWith.length) === startsWith;
    };
    var myApp;
    myApp = myApp || (function () {
        return {
            showPleaseWait: function () {
                $.blockUI({ css: { backgroundColor: '#f00', color: '#fff', border: '3px solid #a00' }, message: dlgElement });
            },
            hidePleaseWait: function () {
                $.unblockUI();
            },

        };
    })();
    var profileId = $.QueryString["id_planificacion"];
    //Inicializar Variables De Datos
    var Vendedores;
    myApp.showPleaseWait();
    var parametros = new Object();
    parametros.id = profileId;
    var jsonText = JSON.stringify(parametros);
    $.ajax({
        url: $.Location + "/GetVendedoresRuteo",
        async: false,
        dataType: 'json',
        data: jsonText,
        type: "POST",
        contentType: "application/json; charset=utf-8",
        cache: false,
        timeout: 24000,
        success: function (json) {
            Vendedores = JSON.parse(json.d).Vendedores;
        },
        complete: function (jqXHR, textStatus) {
            //$.unblockUI();
            myApp.hidePleaseWait();
        }
    });
    //
    var Planificacion = function (planificacion) {
        var self = this;
        self.ID_PLANIFICACION = ko.observable(planificacion ? planificacion[0].ID_PLANIFICACION : 0).extend({ required: true });
        self.FECHA_INICIO = ko.observable(planificacion ? planificacion[0].FECHA_INICIO : '').extend({ required: true });
        self.FECHA_FIN = ko.observable(planificacion ? planificacion[0].FECHA_FIN : '').extend({ required: true});
        self.HORA_INICIO = ko.observable(planificacion ? planificacion[0].HORA_INICIO : '').extend({ required: true});;
        self.HORA_FIN = ko.observable(planificacion ? planificacion[0].HORA_FIN : '').extend({ required: true});;
        self.DESCRIPCION = ko.observable(planificacion ? planificacion[0].DESCRIPCION : '');
        self.ESTADO = ko.observable(planificacion ? planificacion[0].ESTADO : '');
    };
    var PlanificacionCollection = function () {
        var self = this;
        if (profileId == 0) {
            self.planificacion = ko.observable(new Planificacion());
        }
        else {
            myApp.showPleaseWait();
            var parametros = new Object();
            parametros.id = profileId;
            var jsonText = JSON.stringify(parametros);
            $.ajax({
                url: $.Location + "/GetPlanificacionById",
                async: false,
                data: jsonText,
                type: "POST",
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                cache: false,
                timeout: 24000,
                success: function (response) {
                    self.planificacion = ko.observable(new Planificacion(JSON.parse(response.d).Planificacion));
                },
                complete: function (jqXHR, textStatus) {
                    myApp.hidePleaseWait();
                    if (textStatus != "success") {
                        bootbox.dialog({
                            message: "<b>Existio Algun Problema Consultando la Informacion</b><br />Detalle Error:<br />" + JSON.parse(jqXHR.responseText).Message,
                            title: "Error",
                            buttons: {
                                success: {
                                    label: "Continuar",
                                    className: "btn-success",
                                    callback: function () {
                                        window.location.href = '/Asignacion.aspx';
                                    }
                                }
                            }
                        });
                    }
                }
            });
        }
        var refresh = function () {
            //self.Dispositivos(JSON.parse(response.d));
            self.VendedoresSeleccionados($.grep(Vendedores, function (e) {
                return e.SELECCIONADO != 0;
            }));
            self.VendedoresDisponibles($.grep(Vendedores, function (e) {
                return e.SELECCIONADO == 0;
            }));
        };
        self.addToPlanificacion = function (tienda) {
            //alert(tienda);
            self.VendedoresSeleccionados.push(tienda);
            self.VendedoresDisponibles.remove(tienda);
        };
        self.removeFromPlanificacion = function (tienda) {
            self.VendedoresDisponibles.push(tienda);
            self.VendedoresSeleccionados.remove(tienda);
        };
        self.backToPlanificacionList = function () {
            window.location.href = '/Asignacion.aspx';
        };
        self.sortVendedoresDisponibles = function (header, event) {
            var sortKey = header.sortKey;
            switch (sortKey) {
                case 'US_NOMBRE':
                    self.SortState(!self.SortState());
                    self.VendedoresDisponibles.sort(function (a, b) {
                        var result = a.US_NOMBRE < b.US_NOMBRE ? -1 : a.US_NOMBRE > b.US_NOMBRE ? 1 : a.US_NOMBRE == b.US_NOMBRE ? 0 : 0;
                        return self.SortState() === true ? -result : result;
                    });
                    break;
                    /*case 'lName':
                    self.people.sort(function (a, b) {
                    return a.lastName < b.lastName ? -1 : a.lastName > b.lastName ? 1 : a.lastName == b.lastName ? 0 : 0;
                    });
                    break;
                    */
            }
        };
        self.sortStatus = function (header, event) {
            return self.SortState() === true ? "fa fa-chevron-down" : "fa fa-chevron-up";
        };
        self.profileErrors = ko.validation.group(self.planificacion());
        self.saveProfile = function () {
            var isValid = true;
            if (self.profileErrors().length != 0) {
                self.profileErrors.showAllMessages();
                isValid = false;
            }
            if (isValid) {
                myApp.showPleaseWait();
                var parametros = new Object();
                parametros.planificacion = JSON.stringify(ko.toJS(self.planificacion()));
                parametros.vendedores = JSON.stringify(ko.toJS(self.VendedoresSeleccionados()));
                var jsonText = JSON.stringify(parametros);
                $.ajax({
                    url: $.Location + "/SavePlanificacion",
                    data: jsonText,
                    type: "POST",
                    contentType: "application/json; charset=utf-8",
                    dataType: "json",
                    cache: false,
                    timeout: 24000,
                    success: function (response) {
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                    },
                    complete: function (jqXHR, textStatus) {
                        myApp.hidePleaseWait();
                        if (textStatus != "success") {
                            bootbox.dialog({
                                message: "<b>Existio Algun Problema Consultando la Informacion</b><br />Detalle Error:<br />" + JSON.parse(jqXHR.responseText).Message,
                                title: "Error",
                                buttons: {
                                    success: {
                                        label: "Continuar",
                                        className: "btn-success",
                                        callback: function () {
                                        }
                                    }
                                }
                            });
                        }
                        else {
                            bootbox.dialog({
                                message: "Registro Creado Exitosamente",
                                title: "Exito",
                                closeButton: false,
                                buttons: {
                                    success: {
                                        label: "Continuar",
                                        className: "btn-success",
                                        callback: function () {
                                            window.location.href = '/Asignacion.aspx';
                                        }
                                    }
                                }
                            });
                        }
                    }
                });
            }
        };
        // Public data properties
        self.VendedoresSeleccionados = ko.observableArray([]);
        self.VendedoresDisponibles = ko.observableArray([]);
        self.Headers = [{ title: 'Vendedores', sortKey: 'US_NOMBRE' }, { title: '', sortKey: 'Busqueda' }];
        self.SortState = ko.observable(true);
        self.Busqueda = ko.observable('').extend({ throttle: 500 });
        self.Busqueda2 = ko.observable('').extend({ throttle: 500 });
        self.filteredVendedoresDisponibles = ko.computed(function () {
            var filter = self.Busqueda().toLowerCase();
            if (!filter) {
                return self.VendedoresDisponibles();
            }
            else {
                return ko.utils.arrayFilter(self.VendedoresDisponibles(), function (item) {
                   return ko.utils.stringStartsWith(item.US_NOMBRE.toLowerCase(), filter);
                });
            }
        }, self)
        self.filteredVendedoresSeleccionados = ko.computed(function () {
            var filter = self.Busqueda2().toLowerCase();
            if (!filter) {
                return self.VendedoresSeleccionados();
            }
            else {
                return ko.utils.arrayFilter(self.VendedoresSeleccionados(), function (item) {
                    return ko.utils.stringStartsWith(item.US_NOMBRE.toLowerCase(), filter);
                });
            }
        }, self)
        refresh();
    };
    ko.applyBindings(new PlanificacionCollection(), document.getElementById("contenidoPlanificacionCreateEdit"));
});
